#define BLANK -2
#define GOOD (2 + turn)
#define BAD  (3 - turn)

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <malloc.h>
#include <sys/dev.h>
#include <sys/mouse.h>
#include <sys/proxy.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <fcntl.h>
#include <conio.h>
#include <graph.h>
#include "palette.h"

struct Movel
{
    char r,d;
    int points;
    struct  Movel *nxt;
};

void           DrawBoard(), DoMove(), Flip(), PutPiece(), Capture(), SetOptions(), PutMove(), CleanExit(), change_turn();
struct Movel   *InsertMove(), *Moves(), *StripHigh();
unsigned char  CheckOptions();
short           rConvert(), dConvert();
int            CheckEnd(), ValidMove(), count_pieces(), end_game(), max_points();
char           level=1, players=1, turn = 1, *curimg, *invimg;
short		colour[ 2 ];
short          rule[ 8 ][ 2 ] = 
		{ -1, -1, -1, 0, -1, 1, 0, -1, 0, 1, 1, -1, 1, 0, 1, 1 };
char  pmatrix[ 8 ][ 8 ] = 
		{ 120, -120, 45, 45, 45, 45, -120, 120,
                    -120, -120, 5, 5, 5, 5, -120, -120,
                    45, 5, 10, 10, 10, 10, 5, 45,
                    45, 5, 10, 10, 10, 10, 5, 45,   
                    45, 5, 10, 10, 10, 10, 5, 45,
                    45, 5, 10, 10, 10, 10, 5, 45,
                    -120, -120, 5, 5, 5, 5, -120, -120,
                    120, -120, 45, 45, 45, 45, -120, 120
		};
char     board[ 10 ][ 10 ], pointchg[ 8 ][ 8 ];
unsigned char started = 0;

long colors[ 16 ] =
{
	_BLACK, _YELLOW, _LIGHTMAGENTA, _LIGHTRED, _LIGHTCYAN,
	_LIGHTGREEN, _LIGHTBLUE, _GRAY, _WHITE, _BROWN, _MAGENTA,
	_RED, _CYAN, _GREEN, _BLUE, _BRIGHTWHITE
};

	int n, pos_x = 50, pos_y = 50, depth;
	struct _mouse_ctrl *mc;

#ifdef DEBUG
FILE *dbg;
#endif

main(int argc, char *argv[])
{
	struct  Movel *mv, *tml, *tmp; 
	unsigned time_out = 0;
	short    mx,my;
	int cursize;
	struct mouse_event me;
	pid_t mproxy, pid;

#ifdef DEBUG
	dbg = fopen ( "othello.mvs", "w" );
#endif

/* Initialize Mouse */

	mc = mouse_open( (nid_t) 0, 0, 0 );
	if ( ! mc )
	{
		printf( "%cError opening mouse... Is Mouse running?\n", 12 );
		printf( "Try \"Mouse test\"\n" );
		exit( 0 );
	}
	mproxy = qnx_proxy_attach( 0, 0, 0, -1 );
	mouse_flush( mc );
	n = mouse_read( mc, &me, 0, mproxy, NULL );

/* Initialize Play environment */
	depth = 4;

	if( argc > 1) time_out = atoi( argv[ 1 ] );
	if( argc > 2) depth = atoi( argv[ 2 ] );
	memcpy( (void *) pointchg, (void *) pmatrix, 64 );
	memset( board, -1, sizeof( board ) );

	colour[ 0 ] = RED; colour[ 1 ] = BLUE;

	_setvideomode( _VRES16COLOR );
	_remapallpalette( &colors );
	cursize = _imagesize( 0, 0, 10, 10 );
	curimg = malloc( cursize );
	invimg = malloc( cursize );
	if ( ( curimg == NULL ) || ( invimg == NULL ) ) CleanExit();
	DrawBoard( );
	_getimage( 5, 5, 15, 15, invimg);

	for( ; ; )
	{
	_setcolor( WHITE );
	_rectangle( _GFILLINTERIOR, 339, 106, 385, 123 );
	_rectangle( _GFILLINTERIOR, 284, 106, 329, 123 );
	_setcolor( BLUE );
	_rectangle( _GBORDER, 284, 106, 329, 123 );
	_rectangle( _GBORDER, 339, 106, 385, 123 );
	_setcolor( BLACK );
	_moveto( 288, 112 );
	_outgtext( "QUIT!" );
	_moveto( 343, 112 );
	_outgtext( "START" );
	SetOptions( GREEN );

	while( !started )
	{
		draw_cursor( pos_x, pos_y );
		mouse_flush( mc );
		pid = Receive( 0, &me, sizeof( me ) );
		n = mouse_read( mc, &me, 10, mproxy, NULL );
		erase_cursor( pos_x, pos_y );
		if( me.buttons )
			if( pos_x > 256 ) started = CheckOptions( pos_x, pos_y );
		pos_x += me.dx;
		pos_x = ( pos_x > 400 ) ? 400 : ( ( pos_x < 5 ) ? 5 : pos_x );
		pos_y -= me.dy;
		pos_y = ( pos_y > 238 ) ? 238 : ( ( pos_y < 5 ) ? 5 : pos_y );
	}

       for( mx = 1; mx < 9; mx++ )       
           for( my = 1; my < 9; my++ )
               board[ mx ][ my ] = 0;

	DrawBoard(  );
	_setcolor( WHITE );
	_rectangle( _GFILLINTERIOR, 339, 106, 385, 123 );
	_rectangle( _GFILLINTERIOR, 284, 106, 329, 123 );
	_rectangle( _GFILLINTERIOR, 290, 152, 357, 185 );
	_setcolor( BLUE );
	_rectangle( _GBORDER, 284, 106, 329, 123 );
	_rectangle( _GBORDER, 339, 106, 385, 123 );
	_rectangle( _GBORDER, 290, 152, 357, 185 );
	_setcolor( BLACK );
	_moveto( 288, 112 );
	_outgtext( "PASS!" );
	_moveto( 343, 112 );
	_outgtext( "STOP!" );
	_moveto( 294, 168 );
	_outgtext( "Turn" );
	SetOptions( RED );
	turn = 1; change_turn();
	while( started )
	{
		if( ( players == 0 ) || ( ( players == 1 ) && ( turn ) ) )
		{
			if( time_out ) sleep( time_out );
			mv = Moves( board, turn );
			if( mv )
			{
				if( level ) mv = StripHigh( mv );
				tml = mv;
				tmp = mv;
				mx = 0;                
				while( tml )
				{
					mx++;
					tml = tml->nxt;
				}
				srand( time( NULL ) );
				my = rand() % mx;
				for(mx = 0; mx < my; mx++ )
				{
					tml = tmp;
					tmp = tmp->nxt;
					free( (char *) tml );
				}
				DoMove( board, turn, tmp->r, tmp->d );
				while( tmp )
				{
					tml = tmp;
					tmp = tmp->nxt;
					free( (char *) tml );
				}
			}
			else change_turn();
		}
		if( !CheckEnd( board, NULL ) )
		{
			started = 0;
			continue;
		}
		if( ( players == 2 ) || ( ( players ) && ( !turn ) ) )
		{
			draw_cursor( pos_x, pos_y );
			mouse_flush( mc );
			pid = Receive( 0, &me, sizeof( me ) );
			n = mouse_read( mc, &me, 10, mproxy, NULL );
			erase_cursor( pos_x, pos_y );
			if( me.buttons )
				if( pos_x > 256 ) started = CheckOptions( pos_x, pos_y );
				else if( started ) PutMove( pos_x, pos_y );
			pos_x += me.dx;
			pos_x = ( pos_x > 400 ) ? 400 : ( ( pos_x < 5 ) ? 5 : pos_x );
			pos_y -= me.dy;
			pos_y = ( pos_y > 238 ) ? 238 : ( ( pos_y < 5 ) ? 5 : pos_y );
		}
		if( !CheckEnd( board, NULL ) )
			started = 0;
	}
	} /* END for( ;; ) */
}

void
CleanExit()
{
	mouse_close ( mc );
	_setvideomode( _DEFAULTMODE );
	exit( 0 );
}

void
draw_cursor( int x, int y )
{
	_getimage( x - 5, y - 5, x + 5, y + 5, curimg );
	_putimage( x - 5, y - 5, invimg, _GXOR );
}
void
erase_cursor( int x, int y )
{
	_putimage( x - 5, y - 5, curimg, _GPSET );
}

void
DrawBoard( )
{
    int plt = 29, llt = 75;
    int x;

    _setcolor( WHITE );
    _rectangle( _GFILLINTERIOR, 0, 0, 400, 245 );
    _setcolor( BLUE );
    _rectangle( _GBORDER, 0, 0, 400, 245 );

    for( x = 0; x < 9; x++ )
	 {
        _moveto( x*32+3, 3 );
        _lineto( x*32+3, 243 );
    }
    for( x = 0; x < 9; x++ )
	 {
        _moveto( 3, x*30+3 );
        _lineto( 259, x*30+3 );
    }
    _rectangle( _GBORDER, 278, 3, 390, 100 );
    
	_setcolor( BLACK );
	_moveto( 310, 13 );
	_outgtext( "Players" );

    _ellipse( _GBORDER, 320 - 4, plt - 4, 320 + 4, plt + 4 );
    _ellipse( _GBORDER, 336 - 4, plt - 4, 336 + 4, plt + 4 ); 
    _ellipse( _GBORDER, 351 - 4, plt - 4, 351 + 4, plt + 4 );

    _moveto( 317, plt + 8 );
    _outgtext( "0 1 2" );

    _moveto( 318, 60 );
    _outgtext( "Level" );

    _ellipse( _GBORDER, 312 - 4, llt - 4, 312 + 4, llt + 4 );
    _ellipse( _GBORDER, 328 - 4, llt - 4, 328 + 4, llt + 4 );
    _ellipse( _GBORDER, 344 - 4, llt - 4, 344 + 4, llt + 4 );
    _ellipse( _GBORDER, 360 - 4, llt - 4, 360 + 4, llt + 4 );

    _moveto( 309, llt + 8 );
    _outgtext( "1 2 3 4" );

    board[ 4 ][ 4 ] = 3; board[ 5 ][ 5 ] = 3;
    board[ 4 ][ 5 ] = 2; board[ 5 ][ 4 ] = 2;
    turn = 1; PutPiece( 4, 4 ); PutPiece( 5, 5 );
    turn = 0; PutPiece( 4, 5 ); PutPiece( 5, 4 );
}

void
change_turn()
{
	turn = 1 - turn;
	PutPiece( 11, 6 );
}
   
void
DoMove( char bd[10][10], char trn, char r, char d )
{
    char f = 0;
    bd[ d ][ r ] = 2 + trn;
    if( (char *) bd == (char *) board ) f = 1;
    if ( f ) PutPiece( r, d );
    Capture( bd, trn, r, d );
    if ( f ) change_turn();
}

void
Flip( char bd[ 10 ][ 10 ], char trn, char r, char d )

{
    bd[ d ][ r ] = 2 + trn;
    if( (char *) bd == (char *) board ) PutPiece( r, d );
}

void PutPiece(char r, char d)
{
int rt,dt;
    rt = r * 32 - 22;
    dt = d * 30 - 23;
    _setcolor( BLACK );
    _ellipse( _GBORDER, rt, dt, rt + 22, dt + 23 );
    _setcolor( colour[ turn ] );
    _floodfill( rt + 15, dt + 15, -1 );
}

void Capture( char bd[ 10 ][ 10 ], char trn, char r, char d )
{
int x;
    for( x = 0; x < 8; x++ )
        Captured( bd, trn, r, d, x );
}

int
Captured(char bd[10][10], char trn, char r, char d, char rl )
{
    r += rule[ rl ][ 0 ];
    d += rule[ rl ][ 1 ];
    if( bd[ d ][ r ] == 2 + trn ) return 1;
    if( bd[ d ][ r ] != 3 - trn) return 0;
    if( Captured( bd, trn, r, d, rl ) )
	 {
        Flip( bd, trn, r, d );
        return 1;
    }
    return 0;
}

unsigned char
CheckOptions( short r, short d)
{
    if( ( d > 106 ) && ( d < 123 ) && ( r > 339 ) && ( r < 385 ) )
	 {
        started = 1 - started;
	pos_y = 130;
        return started;
    }
    if( ( d > 106 ) && ( d < 123 ) && ( r > 284 ) && ( r < 329 ) )
	 {
        if ( started ) change_turn();
	else CleanExit();
	pos_y = 130;
        return( started );
    }
    if( started ) return 1; 
    if( ( d > 25 ) && ( d < 33 ) )
	 {
        if( ( r > 316 ) && ( r < 324 ) )  players = 0;
        else if ( ( r > 332 ) && ( r < 340 ) ) players = 1;
        else if ( ( r > 347 ) && ( r < 355 ) ) players = 2;
    }
    else if( ( d > 71 ) && ( d < 79 ) )
	 {
        if( ( r > 308 ) && ( r < 316 ) )
				level = 0;
        else if( ( r > 324 ) && ( r < 332 ) )
				level = 1;
        else if( ( r > 340 ) && ( r < 348 ) )
				level = 2;
        else if( ( r > 356 ) && ( r < 364 ) )
				level = 3;
    }
    SetOptions( GREEN );
    return 0;
}

void SetOptions(short clr)
{
   int t;
   short cl[ 4 ];
   int pos[ 2 ][ 4 ];
   pos[ 0 ][ 0 ] = 320;
   pos[ 0 ][ 1 ] = 336;
   pos[ 0 ][ 2 ] = 351;
   pos[ 0 ][ 3 ] = 000;
   pos[ 1 ][ 0 ] = 312;
   pos[ 1 ][ 1 ] = 328;
   pos[ 1 ][ 2 ] = 343;
   pos[ 1 ][ 3 ] = 359;

   for( t = 0; t < 4; t++ ) cl[ t ] = WHITE;
   cl[ players ] = clr;
   for( t = 0; t < 3; t++ )
	{
        _setcolor( cl[ t ] );
        _floodfill( pos[ 0 ][ t ], 29, -1 );
   }
   cl[ players ] = WHITE;
   cl[ level ] = clr;
   for( t = 0; t < 4; t++ )
	{
       _setcolor( cl[ t ] );
       _floodfill( pos[ 1 ][ t ], 75, -1 );
   }
}

struct Movel *InsertMove( char r, char d, int pnt,struct Movel *move_list )
{
	struct Movel *newt;
	newt = (struct Movel *) malloc( sizeof( struct Movel ) );
	if ( newt == NULL ) return ( move_list );
	newt->nxt = move_list;
	newt->points = pnt;
	newt->r = r;
	newt->d = d;
	return newt;
}

int ValidMove(char aboard[ 10 ][ 10 ], char trn, char r, char d )
{
	int points, tpoints;
	char tr, td, mov;
	 
	if( aboard[ d ][ r ] ) return 0;
	points = 0;
	for( mov = 0; mov < 8; mov++ )
	{
		tpoints = 0; tr = r; td = d;
		while( aboard[ ( td += rule[ mov ][ 1 ] ) ][ ( tr += rule[ mov ][ 0 ] ) ] == 3 - trn ) tpoints++;
		if( aboard[ td ][ tr ] == 2 + trn )
			points += tpoints;
	}
	return points;
}

void PutMove(short r, short d)
{
    r = rConvert( r );
    d = dConvert( d );
    if( ValidMove( board, turn , r, d ) ) DoMove( board, turn, r, d );
}

short rConvert(short r)
{
    r -=3;
    r = r / 32 + 1;
    return( r );
}

short dConvert(short d)
{
    d -= 3;
    d = d / 30 + 1;
    return( d );
}


struct Movel *
Moves( nboard, trn )
char nboard[ 10 ][ 10 ], trn;
{
	char r, d;
	struct Movel *mv_list = 0;
	int points;
	 
#ifdef DEBUG
putmsg("-------------------------------------");
#endif
	for( r = 1; r < 9; r++ )
		for( d = 1; d < 9; d++ )
		{
			if( points = ValidMove( nboard, trn, r, d ) )
			{
				points += pmatrix[ d - 1 ][ r - 1 ];
				if ( level > 1 ) points += edge_check( nboard, r, d );
				mv_list = InsertMove( r, d, points, mv_list );
			}
		}
    return mv_list;
}

int
CheckEnd ( char brd[ 10 ][ 10 ], int *win )
{
	int atrn = 0, r, d, amove = 0, bluewin, bluelose ;

	for( atrn = 0; ( ( atrn < 2 ) && ( !amove ) ); atrn++ )
		for( r = 1; ( ( r < 9 ) && ( !amove ) ); r++ )
			for( d = 1; ( ( d < 9 ) && ( !amove ) ); d++ )
				amove = ValidMove( brd, atrn, r, d);
	if( amove == 0 )
	{
		bluewin = bluelose = 0;

		for( r = 1; r < 9; r++ )
			for( d = 1; d < 9; d++ )
			{
				if ( brd[ r ][ d ] == 2 ) bluewin++;
				if ( brd[ r ][ d ] == 3 ) bluelose++;
			}
		if( win )
			*win = bluewin > bluelose ? 0 : 1;
		else
		{
				_setcolor ( WHITE );
				_rectangle ( _GFILLINTERIOR, 290, 152, 357, 185 );
				_setcolor ( BLUE );
				_rectangle ( _GBORDER, 290, 152, 357, 185 );
				_setcolor ( BLACK );
				_moveto ( 294, 168 );
				_outgtext ( "Wins" );
				if( bluewin < bluelose ) 
				{
					turn = 0; change_turn();
				}
				else
				{
					turn = 1; change_turn();
				}
		}
	}
	return( amove );
}

struct Movel *StripHigh(struct Movel *mv)
{
	struct Movel *tmp, *tml;
	int points;
	tmp = NULL;

	points = max_points( mv );
	while( mv )
	{
		tml = mv;
		mv = mv->nxt;
		if( tml->points == points )
		{
			tml->nxt = tmp;
			tmp = tml;
		}
		else free( (struct Movel *) tml);  
	}
	return tmp;
}

int
edge_check ( char brd[ 10 ][ 10 ], int r, int d )
{
	char b1[2], l[ 2 ], e[ 2 ], b2[ 2 ], e2[ 2 ], l2[ 2 ], msg[75];
	char bd[ 10 ][ 10 ];
	int points = 0, gpoints = 0, x, y, dr, dd, tdd, tdr;
	int tr, td, tpoints, ic;


	dr = ( ( d == 1 ) || ( d == 8 ) );
	dd = ( ( r == 1 ) || ( r == 8 ) );

/*** Check for Corner Gift ***/
	if ( ( d==2 || d==7 ) && (r==2 || r==7) )
	{
		memcpy( bd, board, sizeof ( bd ) );
		DoMove( bd, turn, r, d );

		x = r<4?1:-1;
		y = d<4?1:-1;
		td = d+y; tr = r+x;
		for(; bd[td][tr] == GOOD; td += y, tr += x);
		if( bd[td][tr] == BAD )
		{
			#ifdef DEBUG
				sprintf(msg,"%d : %d Corner Gift detected: -400",d,r);
				putmsg(msg);
			#endif
			return -400;
		}
	}

/*	*if ( dd && dr )
 *	*	return ( 100 );
 */
	if ( dd && dr )
		points = 100;

	if ( !( dr || dd ) )
		return ( 0 );

	#ifdef DEBUG
	sprintf(msg, "%d : %d (d:r)",d,r);
	putmsg(msg);
	#endif


/*** Check for capture along the walls ***/

	tr = r; td = d; tpoints = 0;
	while( brd[ td += 1 * dd ][ tr += 1 * dr ] == BAD ) tpoints++;
	if( ( brd[ td ][ tr ] == GOOD ) && ( tpoints ) )
	{
		points = tpoints > 0 ? 75 : 0;
	/** Saving a corner? ***/
		if ( ( brd[ td + 1 * dd ][ tr + 1 * dr ] == 0 ) &&
		 ( ( td + 1 * dd == 8 ) || ( tr + 1 * dr == 8 ) ) )
		{
			points += 75;
			#ifdef DEBUG
				sprintf(msg,"%d : %d wc + saving corner? :+: %d",d,r,points);
				putmsg(msg);
			#endif
		}
	}

	tpoints = 0; tr = r; td = d;
	while( brd[ td -= 1 * dd ][ tr -= 1 * dr ] == BAD ) tpoints++;
	if( ( brd[ td ][ tr ] ) && ( tpoints ) )
	{
		points = tpoints > 0 ? 75 : 0;
	/** Saving a corner? ***/
		if ( ( brd[ td - 1 * dd ][ tr - 1 * dr ] == 0 ) &&
		 ( ( td - 1 * dd == 1 ) || ( tr - 1 * dr == 1 ) ) ) 
		{
			points += 75;
			#ifdef DEBUG
				sprintf(msg,"%d : %d wc + saving corner? :-: %d",d,r,points);
				putmsg(msg);
			#endif
		}
	}


/*** Check for next diagnal from corner capture ***/
/*** If the corner in question is available     ***/

	if( brd[ d<4?1:8 ][ r<4?1:8 ] == 0 )
	{

		/*** Straight in ***/

		tr = r; td = d;
		x = dd * ( r == 8 ? -1 : 1 );
		y = dr * ( d == 8 ? -1 : 1 );
		if( d == 2 || d == 7 || r == 2 || r == 7 )
		{
			while ( brd[ td += 1 * y ][ tr += 1 * x ] == BAD );
			if ( brd[ td ][ tr ] == GOOD )
			{
				points -= 150;
				#ifdef DEBUG
					sprintf(msg,"%d : %d cc Straight in detected : %d",d,r,points);
					putmsg(msg);
				#endif
			}
		}

		/*** And on an angle ***/
		if ( r == 6 || r == 3 || d == 6 || d == 3 )
		{
			y = ( d == 1 || d == 6 ) ? 1 : -1; 
			x = ( r == 1 || r == 6 ) ? 1 : -1; 
			tr = r; td = d;
			if ( ( brd[ td += y ][ tr += x ] == BAD )
			 && ( brd[ td += y ][ tr += x ] == GOOD ) )
			{
				points-=150;
				#ifdef DEBUG
					sprintf(msg,"%d : %d cc Angle in detected : %d",d,r,points);
					putmsg(msg);
				#endif
			}
		}
	}

	memcpy( bd, board, sizeof ( bd ) );
	DoMove( bd, turn, r, d );


	/*** Get b1,l,e,b2,e2,l2 in both dirs ( 0 ->, 1 <- ) ****/
	ic = 1; /** Modifier for corner involvement ( in corner )**/
	for( x = 0; x < 2; x++ )
	{
		b1[ x ] = l[ x ] = e[ x ] = b2[ x ] = e2[ x ] = l2[ x ] = 0;
		tdd = dd * (1 + ( -2 * x ) );
		tdr = dr * (1 + ( -2 * x ) );

		tr = r; td = d;
		td += tdd; tr += tdr;
		
		if ( bd[ td ][ tr ] == 0 )
		{
			b1[x] = 1;
			if ( ( td == 8 * dd || tr == 8 * dr ) ||
			 ( td == 1 * dd || tr == 1 * dr ) )
				ic = 3;
			td += tdd;
			tr += tdr;
		}	
		for ( ; bd[ td ][ tr ] == GOOD; td += tdd, tr += tdr ) l[ x ] += 1;
		for ( ; bd[ td ][ tr ] == BAD; td += tdd, tr += tdr ) e[ x ] = 1;
		if ( bd[ td ][ tr ] == 0 )
		{	
			b2[ x ] = 1;
			if ( ( (td==8 * dd || tr==8 * dr ) ||
			 (td ==1 * dd || tr==1*dr)) && ( ( b1[x] == 0 ) ||
			 l[x]) )
			{
				ic = 2;
				if ( !e[x] ) ic = 3;
			}
			td += tdd;
			tr += tdr;
		}
		if ( bd[ td ][ tr ] == GOOD ) l2[ x ] = 1;
		else if ( bd[ td ][ tr ] == BAD ) e2[ x ] = 1;
		#ifdef DEBUG
		sprintf(msg,"%d : %d [%d]: b1:%d l:%d e:%d b2:%d l2:%d e2:%d",d,r,x,b1[x],l[x],e[x],b2[x],l2[x],e2[x]); 
		putmsg(msg);
		#endif
	} 
	
	/*** Apply move equations in both directions, breaking out when an  ***/
	/*** appropriate move is detected				***/

	#ifdef DEBUG
	sprintf(msg,"%d : %d Points in : %d",d,r,points);
	putmsg(msg);
	#endif

	/*** Emphasize good moves ***/
	for ( x = 0; x < 2; x++ )
	{
		/** SNEAK ATTACK **/
		if( level == 3 )
		if ( ( ( !b1[ x ] ) && e[ x ] && b2[ x ] ) &&
			 ( b1[ 1 - x ] && l[ 1 - x ] && !e[ 1 - x ] ) )
		{
			gpoints += 100;
			#ifdef DEBUG
			sprintf(msg,"%d : %d Sneak Attack : +100",d,r);
			putmsg(msg);
			#endif
		}

		/** All clear **/
		if ( ( b1[ x ] && !l[ x ] ) &&
		 ( b1[ 1 - x ] && ( !l[ 1 - x] ) ) )
		{
			gpoints += 10; /** == +20:will hit twice if hit once **/ 
			#ifdef DEBUG
			sprintf(msg,"%d : %d All Clear : +10",d,r);
			putmsg(msg);
			#endif
		}
	}

	/*** Discourage bad moves ***/
	if ( gpoints == 0 )
	for ( x = 0; x < 2; x++ )
	{
		/** Enemy in Waiting **/
		if ( ( b1[ x ] || ( !b1[ x ] && l[ x ] && !e[ x ] && b2[ x ] ) )
		 && ( !b1[ 1 - x ] && e[ 1 - x ] ) )
		{
			gpoints -= 150;
			#ifdef DEBUG
			sprintf(msg,"%d : %d Enemy in Waiting : -150",d,r);
			putmsg(msg);
			#endif
		}

		/** Hole in the Middle **/
/*		if ( b1[ x ] && l[ x ] )   OLD DEF. */
		if( b1[ x ] && ( l[x] || (!l[x] && e[x] && !b2[x] ) ) 
		 && ( b1[1-x] || e[1-x] || b2[1-x] ) )
		{
			gpoints -= 150;
			#ifdef DEBUG
			sprintf(msg,"%d : %d Hole in Middle : -150",d,r);
			putmsg(msg);
			#endif
		}

		/** Sneak Attack Backfire **/
		if ( level == 3 )
		if ((!b1[x] && l[x] && b2[x] && l2[x]) && b1[1-x] )
		{
			gpoints -=150;
			#ifdef DEBUG
			sprintf(msg,"%d : %d Sneak Attack Backfire: -150",d,r);
			putmsg(msg);
			#endif
		}

		/** Open to Enemy Sneak Attack **/
		if ( level == 3 )
		if ( ( b1[x] && !l[x] && !e[x] && b2[x] && e2[x] )
		 && ( b1[1-x] || ( !e[1-x] && b2[1-x] ) ) )
		{
			gpoints -=150;
			#ifdef DEBUG
			sprintf(msg,"%d : %d Open to Attack Detected: -150",d,r);
			putmsg(msg);
			#endif
		}
	}

	 /** Adjust for "Magnitude of Movement" 
	if( gpoints > 1 ) gpoints += ( l[0] + l[1] ) * 40;
	else if( gpoints < 0 ) gpoints -= ( l[0] + l[1] ) * 40;
	**/

	points += gpoints * ic;

			#ifdef DEBUG
			sprintf(msg,"%d : %d Points out: %d",d,r,points);
			putmsg(msg);
			#endif
	return points;
}

int
count_pieces( char brd[10][10], int trn )
{
	int x, y, cnt = 0;
	for ( x = 1; x < 9; x++ )
			for ( y = 1; y < 9; y++ )
				cnt += brd[ x ][ y ] == 2+trn ? 1 : 0;
	return ( cnt );
}

int
max_points ( struct Movel *mv_list )
{
	struct Movel *tptr;
	int max_point= -32000;

	tptr = mv_list;
	while ( tptr )
	{
		max_point = max_point > tptr->points ? max_point : tptr->points;
		tptr = tptr->nxt;
	}
	return ( max_point );
}

#ifdef DEBUG
putmsg( char *string )
{
/*
	_setcolor( WHITE );
	_rectangle ( _GFILLINTERIOR, 20, 250, 450, 300 );
	_moveto( 24, 290 );
	_setcolor( BLACK );
	_outgtext( string );
	getchar();
	_setcolor( WHITE );
	_rectangle ( _GFILLINTERIOR, 20, 250, 450, 300 );
*/
	fprintf(dbg,"%s\n",string);
	return(0);
}
#endif
